﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MySql.Data.MySqlClient;
using System.Data;
using System.Xml;
using System.Text.RegularExpressions;
using System.Collections;
using Common;
using System.Web;

public class mysql
{
        string myConnectionString = "SERVER=localhost;" +
                            "DATABASE=wikigen;" +
                            "UID=root;" +
                            "PASSWORD=password;";
        //create a DataTable to hold the query results
        public DataTable dTable;
        public MySqlDataAdapter adapter;
        public MySqlConnection connection;

        public mysql()
        {
            
        }

        public void CloseDown()
        {
            
        }

        public void saveLayout(string layout)
        {            
            string myInsertQuery = "Update layout SET content=?layout WHERE name='layout'";
            MySqlCommand myCommand = new MySqlCommand(myInsertQuery);
            myCommand.Parameters.AddWithValue("?layout", layout);
            connection = new MySqlConnection(myConnectionString);
            myCommand.Connection = connection;
            connection.Open();
            myCommand.ExecuteNonQuery();
            myCommand.Connection.Close();
        }


        public void saveContent(string id, string content)
        {
            
            string myInsertQuery = "Update menu SET content=?content WHERE id="+id;
            MySqlCommand myCommand = new MySqlCommand(myInsertQuery);
            myCommand.Parameters.AddWithValue("?content", content);
            connection = new MySqlConnection(myConnectionString);
            myCommand.Connection = connection;
            connection.Open();
            myCommand.ExecuteNonQuery();
            myCommand.Connection.Close();

        }

        public void addNewMenuItem(string parent_id,string name)
        {
            
            string clean_name;
            string tmp = (string)this.returnTable("Select clean_name from menu where id=" + parent_id, false).Rows[0].ItemArray[0];
            clean_name = tmp + "/" + HttpUtility.UrlPathEncode(name);
            string myInsertQuery = "INSERT INTO menu (parent, name,clean_name) Values("+parent_id+",'"+name+"','"+clean_name+"')";
            MySqlCommand myCommand = new MySqlCommand(myInsertQuery);
            connection = new MySqlConnection(myConnectionString);
            myCommand.Connection = connection;
            connection.Open();
            myCommand.ExecuteNonQuery();
            myCommand.Connection.Close();

        }
        public string returnLayout()
        {
            return (string)this.returnTable("Select content from layout where name='layout'", false).Rows[0].ItemArray[0];
        }

        public DataTable returnAllCleanUrl()
        {
            return this.returnTable("Select id,clean_name from menu" , false);
        }


        public string returnCleanUrl (string id)
        {
            return (string)this.returnTable("Select clean_name from menu where id=" + id, false).Rows[0].ItemArray[0];
        }
        public string returnContent(string id)
        {
            return (string) this.returnTable("Select content from menu where id=" + id,false).Rows[0].ItemArray[0];
        }


        private void addNavChild(INode<TreeNode> parent)
        {
            TreeNode head = (TreeNode)parent.Data;

            string command = "SELECT id,parent,name,clean_name FROM menu WHERE parent="+head.id;
            DataTable dTable = this.returnTable(command, false);
            foreach (DataRow row in dTable.Rows)
            {
                TreeNode node = new TreeNode((int)row.ItemArray[0], (int)row.ItemArray[1], (string)row.ItemArray[2], (string)row.ItemArray[3]);
                this.addNavChild(parent.AddChild(node));
            }         
        }


        public ITree<TreeNode> getNav(string _id)
        {
            string command = "SELECT id,name,clean_name FROM menu WHERE id="+_id;
            DataTable dTable = this.returnTable(command, false);
            int id = (int)dTable.Rows[0].ItemArray[0];
            string name = (string)dTable.Rows[0].ItemArray[1];
            string clean_name = (string)dTable.Rows[0].ItemArray[2];
            ITree<TreeNode> tree = NodeTree<TreeNode>.NewTree();           
            INode<TreeNode> top = tree.AddChild(new TreeNode(id,id,name,clean_name));
            this.addNavChild(top);
            
            return tree;
        }

        


        public String getLayout(string layout_point)
        {
            if (layout_point == "content" || layout_point == "nav")
            {
                return "split"+layout_point;
            }
            else
            {
                string command = "SELECT content FROM layout WHERE name='" + layout_point + "'";
                DataTable dTable = this.returnTable(command, false);
                string content = (string)dTable.Rows[0].ItemArray[0];

                // Define a case-insensitive regular expression for repeated words.
                Regex rxInsensitive = new Regex(@"\<parse.*/\>");
                // Find matches using case-insensitive regular expression.
                MatchCollection matches = rxInsensitive.Matches(content);
                foreach (Match hit in matches)
                {
                    // Create the XmlParserContext.
                    XmlParserContext context = new XmlParserContext(null, null, null, XmlSpace.None);
                    XmlTextReader tr = new XmlTextReader(hit.ToString(), XmlNodeType.Element, context);
                    //namespace URI of each element.
                    while (tr.Read())
                    {
                        string res = this.getLayout(tr.GetAttribute("value"));
                        content = content.Replace(hit.ToString(), res);
                    }
                    //Close the reader.
                    tr.Close();
                }
                return content;
            }
            
        }



        public DataTable get_meet_people(int id)
        {
            return this.returnTable("SELECT * from person",false);
        }


        private DataTable returnTable(String sqlcommand, bool auto)
        {
            dTable = new DataTable();
            connection = new MySqlConnection(myConnectionString);
            
            MySqlCommand command = connection.CreateCommand();
            adapter = new MySqlDataAdapter();
            adapter.SelectCommand = new MySqlCommand(sqlcommand, connection);
            //new MySqlCommand(query, conn);
            if (auto)
            {
                MySqlCommandBuilder cb = new MySqlCommandBuilder(adapter);
            }
            adapter.Fill(dTable);
            //System.Console.Write("works");
            return dTable;
        }
        
        public DataTable person()
        {
            return this.returnTable("SELECT * FROM person",true);
        }

        public DataTable reference()
        {
            return this.returnTable("SELECT * FROM reference",true);
        }

        public DataTable meetings()
        {
            DataTable tmp = this.returnTable("SELECT * FROM timeline,meetings WHERE meetings.Timepoint = timeline.id_time",false);
            tmp.Columns[tmp.Columns.IndexOf("id")].ReadOnly = true;
            tmp.Columns[tmp.Columns.IndexOf("id_time")].ReadOnly = true;
            tmp.Columns[tmp.Columns.IndexOf("timepoint")].ReadOnly = true;
            //MySqlDataAdapter da = new MySqlDataAdapter();
            MySqlCommand cmd;
            MySqlParameter parm;
            // Create the UpdateCommand.
            cmd = new MySqlCommand("UPDATE meetings,timeline SET timeline.show_wiki=?show_wiki, timeline.starttime=?starttime, timeline.endtime=?endtime, meetings.summary=?summary, meetings.detail=?detail WHERE meetings.id=?oldId AND timeline.id_time=meetings.Timepoint", connection);
            //cmd.Parameters.Add("?id", MySqlDbType.VarChar, 15, "id");
            cmd.Parameters.Add("?summary", MySqlDbType.VarChar, 800, "summary");
            cmd.Parameters.Add("?detail", MySqlDbType.LongText, 0, "detail");
            cmd.Parameters.Add("?starttime", MySqlDbType.DateTime, 0, "starttime");
            cmd.Parameters.Add("?endtime", MySqlDbType.DateTime, 0, "endtime");
            cmd.Parameters.Add("?show_wiki", MySqlDbType.Bit, 1, "show_wiki");
            parm = cmd.Parameters.Add("?oldId", MySqlDbType.Int32, 1, "id");
            parm.SourceVersion = DataRowVersion.Original;
            adapter.UpdateCommand = cmd;


            // Create the Delete Command.
            // DELETE * FROM timeline WHERE id_time=?timepoint ;
            //
            cmd = new MySqlCommand("DELETE FROM timeline WHERE id_time=?timepoint;DELETE FROM meetings WHERE id=?oldid", connection);
            parm = cmd.Parameters.Add("?oldid", MySqlDbType.Int32, 1, "id");          
            parm.SourceVersion = DataRowVersion.Original;
            parm = cmd.Parameters.Add("?timepoint", MySqlDbType.Int32, 1, "timepoint");
            parm.SourceVersion = DataRowVersion.Original;
            adapter.DeleteCommand = cmd;


            // Create the InsertCommand.
            //
            cmd = new MySqlCommand("INSERT INTO timeline (starttime,endtime,show_wiki) VALUES (?starttime,?endtime,?show_wiki); INSERT INTO meetings (summary,detail,Timepoint) VALUES (?summary,?detail, (SELECT id_time FROM timeline WHERE starttime=?starttime AND endtime=?endtime))", connection);
            //cmd.Parameters.Add("?id", MySqlDbType.VarChar, 15, "id");
            cmd.Parameters.Add("?summary", MySqlDbType.VarChar, 800, "summary");
            cmd.Parameters.Add("?detail", MySqlDbType.LongText, 0, "detail");
            cmd.Parameters.Add("?starttime", MySqlDbType.DateTime, 0, "starttime");
            cmd.Parameters.Add("?endtime", MySqlDbType.DateTime, 0, "endtime");
            cmd.Parameters.Add("?show_wiki", MySqlDbType.Bit, 1, "show_wiki");
            //parm = cmd.Parameters.Add("?oldId", MySqlDbType.VarChar, 15, "id");
            //parm.SourceVersion = DataRowVersion.Original;
            adapter.InsertCommand = cmd;

            return tmp;
        }

        public DataTable tasks()
        {
            DataTable tmp = this.returnTable("SELECT * FROM timeline,task WHERE task.Timepoint = timeline.id_time", false);
            tmp.Columns[tmp.Columns.IndexOf("id")].ReadOnly = true;
            tmp.Columns[tmp.Columns.IndexOf("id_time")].ReadOnly = true;
            tmp.Columns[tmp.Columns.IndexOf("timepoint")].ReadOnly = true;
            //MySqlDataAdapter da = new MySqlDataAdapter();
            MySqlCommand cmd;
            MySqlParameter parm;
            // Create the UpdateCommand.
            cmd = new MySqlCommand("UPDATE task,timeline SET timeline.show_wiki=?show_wiki, timeline.starttime=?starttime, timeline.endtime=?endtime, task.summary=?summary, task.detail=?detail WHERE task.id=?oldId AND timeline.id_time=task.Timepoint", connection);
            //cmd.Parameters.Add("?id", MySqlDbType.VarChar, 15, "id");
            cmd.Parameters.Add("?summary", MySqlDbType.VarChar, 800, "summary");
            cmd.Parameters.Add("?detail", MySqlDbType.LongText, 0, "detail");
            cmd.Parameters.Add("?starttime", MySqlDbType.DateTime, 0, "starttime");
            cmd.Parameters.Add("?endtime", MySqlDbType.DateTime, 0, "endtime");
            cmd.Parameters.Add("?show_wiki", MySqlDbType.Bit, 1, "show_wiki");
            parm = cmd.Parameters.Add("?oldId", MySqlDbType.Int32, 1, "id");
            parm.SourceVersion = DataRowVersion.Original;
            adapter.UpdateCommand = cmd;


            // Create the Delete Command.
            // DELETE * FROM timeline WHERE id_time=?timepoint ;
            //
            cmd = new MySqlCommand("DELETE FROM timeline WHERE id_time=?timepoint;DELETE FROM task WHERE id=?oldid", connection);
            parm = cmd.Parameters.Add("?oldid", MySqlDbType.Int32, 1, "id");
            parm.SourceVersion = DataRowVersion.Original;
            parm = cmd.Parameters.Add("?timepoint", MySqlDbType.Int32, 1, "timepoint");
            parm.SourceVersion = DataRowVersion.Original;
            adapter.DeleteCommand = cmd;


            // Create the InsertCommand.
            //
            cmd = new MySqlCommand("INSERT INTO timeline (starttime,endtime,show_wiki) VALUES (?starttime,?endtime,?show_wiki); INSERT INTO task (summary,detail,Timepoint) VALUES (?summary,?detail, (SELECT id_time FROM timeline WHERE starttime=?starttime AND endtime=?endtime))", connection);
            //cmd.Parameters.Add("?id", MySqlDbType.VarChar, 15, "id");
            cmd.Parameters.Add("?summary", MySqlDbType.VarChar, 800, "summary");
            cmd.Parameters.Add("?detail", MySqlDbType.LongText, 0, "detail");
            cmd.Parameters.Add("?starttime", MySqlDbType.DateTime, 0, "starttime");
            cmd.Parameters.Add("?endtime", MySqlDbType.DateTime, 0, "endtime");
            cmd.Parameters.Add("?show_wiki", MySqlDbType.Bit, 1, "show_wiki");
            //parm = cmd.Parameters.Add("?oldId", MySqlDbType.VarChar, 15, "id");
            //parm.SourceVersion = DataRowVersion.Original;
            adapter.InsertCommand = cmd;

            return tmp;
        }


        public DataTable deadlines()
        {
            DataTable tmp = this.returnTable("SELECT * FROM timeline,deadline WHERE deadline.Timepoint = timeline.id_time", false);
            tmp.Columns[tmp.Columns.IndexOf("id")].ReadOnly = true;
            tmp.Columns[tmp.Columns.IndexOf("id_time")].ReadOnly = true;
            tmp.Columns[tmp.Columns.IndexOf("timepoint")].ReadOnly = true;
            //MySqlDataAdapter da = new MySqlDataAdapter();
            MySqlCommand cmd;
            MySqlParameter parm;
            // Create the UpdateCommand.
            cmd = new MySqlCommand("UPDATE deadline,timeline SET timeline.show_wiki=?show_wiki, timeline.starttime=?starttime, timeline.endtime=?endtime, deadline.summary=?summary, deadline.detail=?detail WHERE deadline.id=?oldId AND timeline.id_time=deadline.Timepoint", connection);
            //cmd.Parameters.Add("?id", MySqlDbType.VarChar, 15, "id");
            cmd.Parameters.Add("?summary", MySqlDbType.VarChar, 800, "summary");
            cmd.Parameters.Add("?detail", MySqlDbType.LongText, 0, "detail");
            cmd.Parameters.Add("?starttime", MySqlDbType.DateTime, 0, "starttime");
            cmd.Parameters.Add("?endtime", MySqlDbType.DateTime, 0, "endtime");
            cmd.Parameters.Add("?show_wiki", MySqlDbType.Bit, 1, "show_wiki");
            parm = cmd.Parameters.Add("?oldId", MySqlDbType.Int32, 1, "id");
            parm.SourceVersion = DataRowVersion.Original;
            adapter.UpdateCommand = cmd;


            // Create the Delete Command.
            // DELETE * FROM timeline WHERE id_time=?timepoint ;
            //
            cmd = new MySqlCommand("DELETE FROM timeline WHERE id_time=?timepoint;DELETE FROM deadline WHERE id=?oldid", connection);
            parm = cmd.Parameters.Add("?oldid", MySqlDbType.Int32, 1, "id");
            parm.SourceVersion = DataRowVersion.Original;
            parm = cmd.Parameters.Add("?timepoint", MySqlDbType.Int32, 1, "timepoint");
            parm.SourceVersion = DataRowVersion.Original;
            adapter.DeleteCommand = cmd;


            // Create the InsertCommand.
            //
            cmd = new MySqlCommand("INSERT INTO timeline (starttime,endtime,show_wiki) VALUES (?starttime,?endtime,?show_wiki); INSERT INTO deadline (summary,detail,Timepoint) VALUES (?summary,?detail, (SELECT id_time FROM timeline WHERE starttime=?starttime AND endtime=?endtime))", connection);
            //cmd.Parameters.Add("?id", MySqlDbType.VarChar, 15, "id");
            cmd.Parameters.Add("?summary", MySqlDbType.VarChar, 800, "summary");
            cmd.Parameters.Add("?detail", MySqlDbType.LongText, 0, "detail");
            cmd.Parameters.Add("?starttime", MySqlDbType.DateTime, 0, "starttime");
            cmd.Parameters.Add("?endtime", MySqlDbType.DateTime, 0, "endtime");
            cmd.Parameters.Add("?show_wiki", MySqlDbType.Bit, 1, "show_wiki");
            //parm = cmd.Parameters.Add("?oldId", MySqlDbType.VarChar, 15, "id");
            //parm.SourceVersion = DataRowVersion.Original;
            adapter.InsertCommand = cmd;

            return tmp;
        }







  


}
